unit UserDetails;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Samples.Spin, Vcl.ComCtrls, Data.DB, Data.Win.ADODB;

type
    TRegistrantDetails = record
        ID: String;
        RegistrationName: String;
        Email: String;
        RegistrationTime: TDateTime;
        Comments: String;
        //* V4
        Salutation: String;
        Title: String;
        LastName: String;
        FirstName: String;
        Company: String;
        ContactName: String;
        Address: String;
        City: String;
        FullCity: String;
        Country: String;
        PostalCode: String;
        StateProvince: String;
        Telephone: String;
        MobilePhone: String;
        Fax: String;
        HomePage: String;
        AcceptsNewsLetters: Boolean;
        VATID: String;
        NoOfLicenses: Integer;
        Language: String;
        ShareItRefNo: String;
        Reseller: String;
        PromotionName: String;
        NetSalesCurrency: String;
        NetSales: Currency;
        NetDiscountCurrency: String;
        NetDiscount: Currency;
        CollectedVATCurrency: String;
        CollectedVAT: Currency;
        ShippingCurrency: String;
        Shipping: Currency;
        VATShippingCurrency: String;
        VATShipping: Currency;
        TotalCurrency: String;
        Total: Currency;
        Payment: String;
        DeliveryMode: String;
        ShareItOrderEMail: String;
    end;

type
  TFormRegistrantDetails = class(TForm)
    GroupBoxContainer: TGroupBox;
    ButtonSave: TButton;
    ButtonCancel: TButton;
    EditCustomerID: TEdit;
    LabelCustomerID: TLabel;
    EditCustomerLastName: TEdit;
    LabelCustomerLastName: TLabel;
    LabelCustomerCompany: TLabel;
    EditCustomerCompany: TEdit;
    EditCustomerContactName: TEdit;
    LabelCustomerContactName: TLabel;
    LabelCustomerAddress: TLabel;
    EditCustomerAddress: TEdit;
    EditCustomerCity: TEdit;
    LabelCustomerCity: TLabel;
    EditCustomerState: TEdit;
    LabelCustomerState: TLabel;
    EditCustomerPostalCode: TEdit;
    LabelCustomerPostalCode: TLabel;
    EditCustomerTelephone: TEdit;
    LabelCustomerTelephone: TLabel;
    LabelCustomerMobile: TLabel;
    EditCustomerMobile: TEdit;
    EditCustomerFax: TEdit;
    LabelCustomerFax: TLabel;
    LabelCustomerEmail: TLabel;
    EditCustomerEmail: TEdit;
    ButtonCustomerWriteEmail: TButton;
    ButtonCustomerVisitHomePage: TButton;
    EditCustomerHomePage: TEdit;
    LabelCustomerHomePage: TLabel;
    LabelCustomerRegistrationDate: TLabel;
    MemoCustomerComments: TMemo;
    GroupBoxOrderDetails: TGroupBox;
    EditShareItRefNo: TEdit;
    LabelShareItRefNo: TLabel;
    EditNetSalesCurrency: TEdit;
    LabelNetSales: TLabel;
    EditNetSalesValue: TEdit;
    EditNetDiscountValue: TEdit;
    EditNetDiscountCurrency: TEdit;
    LabelNetDiscount: TLabel;
    EditcollectedVATValue: TEdit;
    EditcollectedVATCurrency: TEdit;
    LabelCollectedVAT: TLabel;
    EditShippingValue: TEdit;
    EditShippingCurrency: TEdit;
    LabelShipping: TLabel;
    EditVATOnShippingValue: TEdit;
    EditVATOnShippingCurrency: TEdit;
    LabelVATOnShipping: TLabel;
    EditTotalValue: TEdit;
    EditTotalCurrency: TEdit;
    LabelTotal: TLabel;
    EditCustomerSalutation: TEdit;
    LabelCustomerSalutation: TLabel;
    EditCustomerTitle: TEdit;
    LabeCustomerTitle: TLabel;
    EditCustomerFirstName: TEdit;
    LabelCustomerFirstName: TLabel;
    EditCustomerFullCity: TEdit;
    LabelCustomerFullCity: TLabel;
    EditCustomerCountry: TEdit;
    LabelCustomerCountry: TLabel;
    EditCustomerVATID: TEdit;
    LabelCustomerVATID: TLabel;
    EditPaymentValue: TEdit;
    LabelPayment: TLabel;
    EditCustomerRegistrationName: TEdit;
    LabelCustomerRegistrationName: TLabel;
    EditCustomerLanguage: TEdit;
    LabelCustomerLanguage: TLabel;
    GroupBoxComments: TGroupBox;
    ButtonGenerateRegistrationName: TButton;
    EditDeliveryModeValue: TEdit;
    LabelDeliveryMode: TLabel;
    CheckBoxNewsletter: TCheckBox;
    DateTimePickerRegistrationDate: TDateTimePicker;
    EditResellerValue: TEdit;
    LabelReseller: TLabel;
    EditPromotionName: TEdit;
    LabelPromotionName: TLabel;
    ADOQuery: TADOQuery;
    ADOConnection: TADOConnection;
    DataSource: TDataSource;
    SpinEditNumberOfLicenses: TSpinEdit;
    LabelNumberOfLicenses: TLabel;
    DateTimePickerRegistrationTime: TDateTimePicker;
    LabelCustomerRegistrationTime: TLabel;
    procedure ButtonGenerateRegistrationNameClick(Sender: TObject);
    procedure ButtonCustomerWriteEmailClick(Sender: TObject);
    procedure ButtonCustomerVisitHomePageClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ProjectName: String;
    procedure Clear;
    procedure ProcessShareItEMail(EMailText: TStrings);
    function SQLUpdateRegistration(ProjectTableName: String): Integer;
    function SQLLoadRegistration(ProjectTableName: String; UserID: String; var RegistrantDetails: TRegistrantDetails): Integer;
    procedure LoadRegistration(ProjectTableName: String; UserID: String);
    function OrderAlreadyInDataBase(ProjectTableName: String; OrderID: String): Boolean;
    //function TFormRegistrantDetails.GetUserRegistrationFromDataBase(ProjectTableName: AnsiString; RegistrationNumber: String): Boolean;
  end;

var
  FormRegistrantDetails: TFormRegistrantDetails;

implementation

{$R *.dfm}

Uses
    StrUtils,
    ShellAPI,
    Settings,
    DateUtils,
    Main,
    Helper3delite;

function GetValueOf(Data: String; Text: TStrings): String;
var
  i: Integer;
begin
	for i := 0 to Text.Count - 1 do begin
    	if UpperCase(Text[i]).StartsWith(UpperCase(Data)) then begin
            Result := Copy(Text[i], Pos('=', Text[i]) + 2, Length(Text[i]));
            Result := Trim(Result);
            Exit;
        end;
    end;
end;

function GetTrailingOf(Data: String; Text: TStrings): String;
var
  i: Integer;
begin
	for i := 0 to Text.Count - 1 do begin
    	if UpperCase(Text[i]).StartsWith(UpperCase(Data)) then begin
            Result := Copy(Text[i], Length(Data) + 1, Length(Text[i]));
            Exit;
        end;
    end;
end;

procedure TFormRegistrantDetails.ButtonGenerateRegistrationNameClick(Sender: TObject);
begin
    EditCustomerRegistrationName.Text := EditCustomerFirstName.Text + ' ' + EditCustomerLastName.Text;
end;

procedure TFormRegistrantDetails.ButtonCustomerVisitHomePageClick(Sender: TObject);
begin
    ShellExecute(Handle,'open', PChar(EditCustomerHomePage.Text), nil, nil, SW_SHOWNORMAL);
end;

procedure TFormRegistrantDetails.ButtonCustomerWriteEmailClick(Sender: TObject);
var
    MailToString: String;
begin
    MailToString := 'mailto:' + EditCustomerEmail.Text + '?subject=' + ProjectName;
    ShellExecute(Handle,'open', PChar(MailToString), nil, nil, SW_SHOWNORMAL);
end;

procedure TFormRegistrantDetails.Clear;
begin
    EditCustomerID.Text := '';
    EditCustomerLastName.Text := '';
    EditCustomerCompany.Text := '';
    EditCustomerContactName.Text := '';
    EditCustomerAddress.Text := '';
    EditCustomerCity.Text := '';
    EditCustomerState.Text := '';
    EditCustomerPostalCode.Text := '';
    EditCustomerTelephone.Text := '';
    EditCustomerMobile.Text := '';
    EditCustomerFax.Text := '';
    EditCustomerEmail.Text := '';
    EditCustomerHomePage.Text := '';
    DateTimePickerRegistrationDate.Date:= Now;
    DateTimePickerRegistrationTime.Time:= Now;
    MemoCustomerComments.Text := '';
    SpinEditNumberOfLicenses.Value := 0;
    EditShareItRefNo.Text := '';
    EditResellerValue.Text := '';
    EditPromotionName.Text := '';
    EditNetSalesCurrency.Text := '';
    EditNetSalesValue.Text := '';
    EditNetDiscountValue.Text := '';
    EditNetDiscountCurrency.Text := '';
    EditcollectedVATValue.Text := '';
    EditcollectedVATCurrency.Text := '';
    EditShippingValue.Text := '';
    EditShippingCurrency.Text := '';
    EditVATOnShippingValue.Text := '';
    EditVATOnShippingCurrency.Text := '';
    EditTotalValue.Text := '';
    EditTotalCurrency.Text := '';
    EditCustomerSalutation.Text := '';
    EditCustomerTitle.Text := '';
    EditCustomerFirstName.Text := '';
    EditCustomerFullCity.Text := '';
    EditCustomerCountry.Text := '';
    EditCustomerVATID.Text := '';
    EditPaymentValue.Text := '';
    EditCustomerRegistrationName.Text := '';
    EditCustomerLanguage.Text := '';
    EditDeliveryModeValue.Text := '';
end;

procedure TFormRegistrantDetails.ProcessShareItEMail(EMailText: TStrings);
var
    CurrencyText: String;
    Value: String;
    RegistrationNameNumbers: Integer;
begin

    if FormSettings.CheckBoxLogDebug.Checked then begin
        LogStrings(FormSettings.EditLogFileName.Text, DateTimeToStr(Now) + ' ProcessShareItEMail: START -------------' + #13#10 + EMailText.Text);
    end;

    SpinEditNumberOfLicenses.Value := StrToIntDef(GetValueOf('Number of licenses', EMailText), 0);

    EditShareItRefNo.Text := GetValueOf('ShareIt Ref #', EMailText);

    EditResellerValue.Text := GetValueOf('Reseller', EMailText);

    EditPromotionName.Text := GetValueOf('Promotion name', EMailText);

    CurrencyText := GetValueOf('Net sales', EMailText);
    EditNetSalesCurrency.Text := Copy(CurrencyText, 1, 3);
    EditNetSalesValue.Text := Trim(Copy(CurrencyText, 4, Length(CurrencyText)));

    CurrencyText := GetValueOf('Net Discount', EMailText);
    EditNetDiscountCurrency.Text := Copy(CurrencyText, 1, 3);
    EditNetDiscountValue.Text := Trim(Copy(CurrencyText, 4, Length(CurrencyText)));

    CurrencyText := GetValueOf('collected VAT', EMailText);
    EditcollectedVATCurrency.Text := Copy(CurrencyText, 1, 3);
    EditcollectedVATValue.Text := Trim(Copy(CurrencyText, 4, Length(CurrencyText)));

    CurrencyText := GetValueOf('Shipping', EMailText);
    EditShippingCurrency.Text := Copy(CurrencyText, 1, 3);
    EditShippingValue.Text := Trim(Copy(CurrencyText, 4, Length(CurrencyText)));

    CurrencyText := GetValueOf('VAT on Shipping', EMailText);
    EditVATOnShippingCurrency.Text := Copy(CurrencyText, 1, 3);
    EditVATOnShippingValue.Text := Trim(Copy(CurrencyText, 4, Length(CurrencyText)));

    CurrencyText := GetValueOf('Total', EMailText);
    EditTotalCurrency.Text := Copy(CurrencyText, 1, 3);
    EditTotalValue.Text := Trim(Copy(CurrencyText, 4, Length(CurrencyText)));

    EditCustomerSalutation.Text := GetValueOf('Salutation', EMailText);

    EditCustomerTitle.Text := GetValueOf('Title', EMailText);

    EditCustomerLastName.Text := GetValueOf('Last Name', EMailText);

    EditCustomerFirstName.Text := GetValueOf('First Name', EMailText);

    EditCustomerCompany.Text := GetValueOf('Company', EMailText);

    EditCustomerAddress.Text := GetValueOf('Street', EMailText);

    EditCustomerPostalCode.Text := GetValueOf('ZIP', EMailText);

    EditCustomerCity.Text := GetValueOf('City', EMailText);

    EditCustomerFullCity.Text := GetValueOf('FullCity', EMailText);

    EditCustomerCountry.Text := GetValueOf('Country', EMailText);

    EditCustomerState.Text := GetValueOf('State / Province', EMailText);

    EditCustomerTelephone.Text := GetValueOf('Phone', EMailText);

    EditCustomerFax.Text := GetValueOf('Fax', EMailText);

    EditCustomerEmail.Text := GetValueOf('E-Mail', EMailText);

    EditCustomerVATID.Text := GetValueOf('VAT ID', EMailText);

    EditPaymentValue.Text := GetValueOf('Payment', EMailText);

    EditCustomerRegistrationName.Text := GetValueOf('Registration name', EMailText);

    EditCustomerLanguage.Text := GetValueOf('Language', EMailText);

    Value := GetTrailingOf('The customer selected the following delivery type: ', EMailText);
    EditDeliveryModeValue.Text := Copy(Value, 1, Length(Value) - 1);

    CheckBoxNewsletter.Checked := True;

    DateTimePickerRegistrationDate.DateTime := Now;
    DateTimePickerRegistrationTime.Time := Now;

    //* Home or private
    if SameText(EditCustomerRegistrationName.Text, 'Home')
    OR SameText(EditCustomerRegistrationName.Text, 'Home use')
    OR SameText(EditCustomerRegistrationName.Text, 'For home use')
    OR SameText(EditCustomerRegistrationName.Text, 'Personal')
    OR SameText(EditCustomerRegistrationName.Text, 'Personal use')
    OR SameText(EditCustomerRegistrationName.Text, 'For personal use')
    OR SameText(EditCustomerRegistrationName.Text, 'Private')
    OR ContainsText(EditCustomerRegistrationName.Text, 'Privat')
    OR ContainsText(EditCustomerRegistrationName.Text, 'Registration')
    //* App name specified
    OR ContainsText(EditCustomerRegistrationName.Text, ProjectName)
    //* Empty
    OR (Trim(EditCustomerRegistrationName.Text) = '')
    then begin
        ButtonGenerateRegistrationNameClick(nil);
    end;
    //* The product ID was entered
    if Length(EditCustomerRegistrationName.Text) = 9 then begin
        RegistrationNameNumbers := StrToIntDef(EditCustomerRegistrationName.Text, - 1);
        if RegistrationNameNumbers <> - 1 then begin
            ButtonGenerateRegistrationNameClick(nil);
        end;
    end;

    if FormSettings.CheckBoxLogDebug.Checked then begin
        LogStrings(FormSettings.EditLogFileName.Text, DateTimeToStr(Now) + ' ProcessShareItEMail: END -------------');
    end;
end;

function TFormRegistrantDetails.SQLUpdateRegistration(ProjectTableName: String): Integer;
var
    RegistrationDateTime: TDateTime;
    Year, Month, Day, Hour, Minute, Second, MilliSecond: Word;
begin

    Result := 0;

    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.SQL.Clear;

    //* Set to use our new database (specified by name)
    ADOQuery.SQL.Add('USE ' + FormSettings.EditDatabaseNameToUse.Text + ';');

    //* Insert a new record
    ADOQuery.SQL.Add('UPDATE ' + ProjectTableName);
    ADOQuery.SQL.Add('SET');
    ADOQuery.SQL.Add(CN_USER_REGISTRATIONNAME + ' = :CN_USER_REGISTRATIONNAME,');
    ADOQuery.SQL.Add(CN_USER_EMAIL + ' = :CN_USER_EMAIL,');
    ADOQuery.SQL.Add(CN_USER_REG_TIME + ' = :CN_USER_REG_TIME,');
    ADOQuery.SQL.Add(CN_USER_COMMENTS + ' = :CN_USER_COMMENTS,');
    ADOQuery.SQL.Add(CN_USER_SALUTATION + ' = :CN_USER_SALUTATION,');
    ADOQuery.SQL.Add(CN_USER_TITLE + ' = :CN_USER_TITLE,');
    ADOQuery.SQL.Add(CN_USER_LASTNAME + ' = :CN_USER_LASTNAME,');
    ADOQuery.SQL.Add(CN_USER_FIRSTNAME + ' = :CN_USER_FIRSTNAME,');
    ADOQuery.SQL.Add(CN_USER_COMPANY + ' = :CN_USER_COMPANY,');
    ADOQuery.SQL.Add(CN_USER_CONTACTNAME + ' = :CN_USER_CONTACTNAME,');
    ADOQuery.SQL.Add(CN_USER_ADDRESS + ' = :CN_USER_ADDRESS,');
    ADOQuery.SQL.Add(CN_USER_CITY + ' = :CN_USER_CITY,');
    ADOQuery.SQL.Add(CN_USER_FULLCITY + ' = :CN_USER_FULLCITY,');
    ADOQuery.SQL.Add(CN_USER_COUNTRY + ' = :CN_USER_COUNTRY,');
    ADOQuery.SQL.Add(CN_USER_POSTALCODE + ' = :CN_USER_POSTALCODE,');
    ADOQuery.SQL.Add(CN_USER_STATEPROVINCE + ' = :CN_USER_STATEPROVINCE,');
    ADOQuery.SQL.Add(CN_USER_TELEPHONE + ' = :CN_USER_TELEPHONE,');
    ADOQuery.SQL.Add(CN_USER_MOBILEPHONE + ' = :CN_USER_MOBILEPHONE,');
    ADOQuery.SQL.Add(CN_USER_FAX + ' = :CN_USER_FAX,');
    ADOQuery.SQL.Add(CN_USER_HOMEPAGE + ' = :CN_USER_HOMEPAGE,');
    ADOQuery.SQL.Add(CN_USER_NEWSLETTER + ' = :CN_USER_NEWSLETTER,');
    ADOQuery.SQL.Add(CN_USER_VATID + ' = :CN_USER_VATID,');
    ADOQuery.SQL.Add(CN_USER_NOOFLICENSES + ' = :CN_USER_NOOFLICENSES,');
    ADOQuery.SQL.Add(CN_USER_LANGUAGE + ' = :CN_USER_LANGUAGE,');
    ADOQuery.SQL.Add(CN_USER_SHAREITREFNO + ' = :CN_USER_SHAREITREFNO,');
    ADOQuery.SQL.Add(CN_USER_RESELLER + ' = :CN_USER_RESELLER,');
    ADOQuery.SQL.Add(CN_USER_PROMOTIONNAME + ' = :CN_USER_PROMOTIONNAME,');
    ADOQuery.SQL.Add(CN_USER_NETSALESCURRENCY + ' = :CN_USER_NETSALESCURRENCY,');
    ADOQuery.SQL.Add(CN_USER_NETSALES + ' = :CN_USER_NETSALES,');
    ADOQuery.SQL.Add(CN_USER_NETDISCOUNTCURRENCY + ' = :CN_USER_NETDISCOUNTCURRENCY,');
    ADOQuery.SQL.Add(CN_USER_NETDISCOUNT + ' = :CN_USER_NETDISCOUNT,');
    ADOQuery.SQL.Add(CN_USER_COLLECTEDVATCURRENCY + ' = :CN_USER_COLLECTEDVATCURRENCY,');
    ADOQuery.SQL.Add(CN_USER_COLLECTEDVAT + ' = :CN_USER_COLLECTEDVAT,');
    ADOQuery.SQL.Add(CN_USER_SHIPPINGCURRENCY + ' = :CN_USER_SHIPPINGCURRENCY,');
    ADOQuery.SQL.Add(CN_USER_SHIPPING + ' = :CN_USER_SHIPPING,');
    ADOQuery.SQL.Add(CN_USER_VATSHIPPINGCURRENCY + ' = :CN_USER_VATSHIPPINGCURRENCY,');
    ADOQuery.SQL.Add(CN_USER_VATSHIPPING + ' = :CN_USER_VATSHIPPING,');
    ADOQuery.SQL.Add(CN_USER_TOTALCURRENCY + ' = :CN_USER_TOTALCURRENCY,');
    ADOQuery.SQL.Add(CN_USER_TOTAL + ' = :CN_USER_TOTAL,');
    ADOQuery.SQL.Add(CN_USER_PAYMENT + ' = :CN_USER_PAYMENT,');
    ADOQuery.SQL.Add(CN_USER_DELIVERYMODE + ' = :CN_USER_DELIVERYMODE');
    //ADOQuery.SQL.Add(CN_USER_SHAREITORDEREMAIL + ' = :CN_USER_SHAREITORDEREMAIL');
    ADOQuery.SQL.Add('WHERE ' + CN_USER_ID + ' = ' + EditCustomerID.Text);

    //* Specify the values and their data type ftWideString = unicode
    ADOQuery.Parameters.ParamByName('CN_USER_REGISTRATIONNAME').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_REGISTRATIONNAME').Value := EditCustomerRegistrationName.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_EMAIL').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_EMAIL').Value := EditCustomerEmail.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_COMMENTS').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_COMMENTS').Value := MemoCustomerComments.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_SALUTATION').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_SALUTATION').Value := EditCustomerSalutation.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_TITLE').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_TITLE').Value := EditCustomerTitle.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_LASTNAME').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_LASTNAME').Value := EditCustomerLastName.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_FIRSTNAME').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_FIRSTNAME').Value := EditCustomerFirstName.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_COMPANY').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_COMPANY').Value := EditCustomerCompany.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_CONTACTNAME').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_CONTACTNAME').Value := EditCustomerContactName.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_ADDRESS').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_ADDRESS').Value := EditCustomerAddress.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_CITY').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_CITY').Value := EditCustomerCity.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_FULLCITY').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_FULLCITY').Value := EditCustomerFullCity.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_COUNTRY').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_COUNTRY').Value := EditCustomerCountry.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_POSTALCODE').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_POSTALCODE').Value := EditCustomerPostalCode.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_STATEPROVINCE').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_STATEPROVINCE').Value := EditCustomerState.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_TELEPHONE').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_TELEPHONE').Value := EditCustomerTelephone.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_MOBILEPHONE').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_MOBILEPHONE').Value := EditCustomerMobile.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_FAX').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_FAX').Value := EditCustomerFax.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_HOMEPAGE').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_HOMEPAGE').Value := EditCustomerHomePage.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_NEWSLETTER').DataType := ftBoolean;
    ADOQuery.Parameters.ParamByName('CN_USER_NEWSLETTER').Value := CheckBoxNewsletter.Checked;
    ADOQuery.Parameters.ParamByName('CN_USER_VATID').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_VATID').Value := EditCustomerVATID.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_NOOFLICENSES').DataType := ftInteger;
    ADOQuery.Parameters.ParamByName('CN_USER_NOOFLICENSES').Value := SpinEditNumberOfLicenses.Value;
    ADOQuery.Parameters.ParamByName('CN_USER_LANGUAGE').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_LANGUAGE').Value := EditCustomerLanguage.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_SHAREITREFNO').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_SHAREITREFNO').Value := EditShareItRefNo.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_RESELLER').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_RESELLER').Value := EditResellerValue.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_PROMOTIONNAME').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_PROMOTIONNAME').Value := EditPromotionName.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_NETSALESCURRENCY').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_NETSALESCURRENCY').Value := EditNetSalesCurrency.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_NETSALES').DataType := ftCurrency;
    ADOQuery.Parameters.ParamByName('CN_USER_NETSALES').Value := EditNetSalesValue.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_NETDISCOUNTCURRENCY').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_NETDISCOUNTCURRENCY').Value := EditNetDiscountCurrency.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_NETDISCOUNT').DataType := ftCurrency;
    ADOQuery.Parameters.ParamByName('CN_USER_NETDISCOUNT').Value := EditNetDiscountValue.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_COLLECTEDVATCURRENCY').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_COLLECTEDVATCURRENCY').Value := EditcollectedVATCurrency.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_COLLECTEDVAT').DataType := ftCurrency;
    ADOQuery.Parameters.ParamByName('CN_USER_COLLECTEDVAT').Value := EditcollectedVATValue.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_SHIPPINGCURRENCY').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_SHIPPINGCURRENCY').Value := EditShippingCurrency.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_SHIPPING').DataType := ftCurrency;
    ADOQuery.Parameters.ParamByName('CN_USER_SHIPPING').Value := EditShippingValue.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_VATSHIPPINGCURRENCY').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_VATSHIPPINGCURRENCY').Value := EditVATOnShippingCurrency.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_VATSHIPPING').DataType := ftCurrency;
    ADOQuery.Parameters.ParamByName('CN_USER_VATSHIPPING').Value := EditVATOnShippingValue.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_TOTALCURRENCY').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_TOTALCURRENCY').Value := EditTotalCurrency.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_TOTAL').DataType := ftCurrency;
    ADOQuery.Parameters.ParamByName('CN_USER_TOTAL').Value := EditTotalValue.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_PAYMENT').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_PAYMENT').Value := EditPaymentValue.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_DELIVERYMODE').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('CN_USER_DELIVERYMODE').Value := EditDeliveryModeValue.Text;
    ADOQuery.Parameters.ParamByName('CN_USER_REG_TIME').DataType := ftDateTime;
    //* Generate a TDateTime from date and time picker
    DecodeDate(DateTimePickerRegistrationDate.Date, Year, Month, Day);
    DecodeTime(DateTimePickerRegistrationTime.Time, Hour, Minute, Second, MilliSecond);
    RegistrationDateTime := EncodeDateTime(Year, Month, Day, Hour, Minute, Second, MilliSecond);
    ADOQuery.Parameters.ParamByName('CN_USER_REG_TIME').Value := RegistrationDateTime;

    ADOQuery.ExecSql;

    ADOQuery.Close;
    ADOConnection.Close;

end;

function TFormRegistrantDetails.SQLLoadRegistration(ProjectTableName: String; UserID: String; var RegistrantDetails: TRegistrantDetails): Integer;
begin

    Result := 0;

    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.SQL.Clear;

    //* Set to use our new database (specified by name)
    ADOQuery.SQL.Add('USE ' + FormSettings.EditDatabaseNameToUse.Text + ';');

    //* Insert a new record
    ADOQuery.SQL.Add('SELECT * FROM ' + ProjectTableName);
    ADOQuery.SQL.Add('WHERE ' + CN_USER_ID + ' = ' + UserID);
    ADOQuery.Open;

    if DataSource.DataSet.IsEmpty then begin
        Exit;
    end;

    DataSource.DataSet.First;
    with RegistrantDetails do begin
        ID := DataSource.DataSet.FieldByName(CN_USER_ID).AsWideString;
        RegistrationName := DataSource.DataSet.FieldByName(CN_USER_REGISTRATIONNAME).AsWideString;
        Email := DataSource.DataSet.FieldByName(CN_USER_EMAIL).AsWideString;
        RegistrationTime := DataSource.DataSet.FieldByName(CN_USER_REG_TIME).AsDateTime;
        Comments := DataSource.DataSet.FieldByName(CN_USER_COMMENTS).AsWideString;
        //* V4
        Salutation := DataSource.DataSet.FieldByName(CN_USER_SALUTATION).AsWideString;
        Title := DataSource.DataSet.FieldByName(CN_USER_TITLE).AsWideString;
        LastName := DataSource.DataSet.FieldByName(CN_USER_LASTNAME).AsWideString;
        FirstName := DataSource.DataSet.FieldByName(CN_USER_FIRSTNAME).AsWideString;
        Company := DataSource.DataSet.FieldByName(CN_USER_COMPANY).AsWideString;
        ContactName := DataSource.DataSet.FieldByName(CN_USER_CONTACTNAME).AsWideString;
        Address := DataSource.DataSet.FieldByName(CN_USER_ADDRESS).AsWideString;
        City := DataSource.DataSet.FieldByName(CN_USER_CITY).AsWideString;
        FullCity := DataSource.DataSet.FieldByName(CN_USER_FULLCITY).AsWideString;
        Country := DataSource.DataSet.FieldByName(CN_USER_COUNTRY).AsWideString;
        PostalCode := DataSource.DataSet.FieldByName(CN_USER_POSTALCODE).AsWideString;
        StateProvince := DataSource.DataSet.FieldByName(CN_USER_STATEPROVINCE).AsWideString;
        Telephone := DataSource.DataSet.FieldByName(CN_USER_TELEPHONE).AsWideString;
        MobilePhone := DataSource.DataSet.FieldByName(CN_USER_MOBILEPHONE).AsWideString;
        Fax := DataSource.DataSet.FieldByName(CN_USER_FAX).AsWideString;
        HomePage := DataSource.DataSet.FieldByName(CN_USER_HOMEPAGE).AsWideString;
        AcceptsNewsLetters := DataSource.DataSet.FieldByName(CN_USER_NEWSLETTER).AsBoolean;
        VATID := DataSource.DataSet.FieldByName(CN_USER_VATID).AsWideString;
        NoOfLicenses := DataSource.DataSet.FieldByName(CN_USER_NOOFLICENSES).AsInteger;
        Language := DataSource.DataSet.FieldByName(CN_USER_LANGUAGE).AsWideString;
        ShareItRefNo := DataSource.DataSet.FieldByName(CN_USER_SHAREITREFNO).AsWideString;
        Reseller := DataSource.DataSet.FieldByName(CN_USER_RESELLER).AsWideString;
        PromotionName := DataSource.DataSet.FieldByName(CN_USER_PROMOTIONNAME).AsWideString;
        NetSalesCurrency := DataSource.DataSet.FieldByName(CN_USER_NETSALESCURRENCY).AsWideString;
        NetSales := DataSource.DataSet.FieldByName(CN_USER_NETSALES).AsCurrency;
        NetDiscountCurrency := DataSource.DataSet.FieldByName(CN_USER_NETDISCOUNTCURRENCY).AsWideString;
        NetDiscount := DataSource.DataSet.FieldByName(CN_USER_NETDISCOUNT).AsCurrency;
        CollectedVATCurrency := DataSource.DataSet.FieldByName(CN_USER_COLLECTEDVATCURRENCY).AsWideString;
        CollectedVAT := DataSource.DataSet.FieldByName(CN_USER_COLLECTEDVAT).AsCurrency;
        ShippingCurrency := DataSource.DataSet.FieldByName(CN_USER_SHIPPINGCURRENCY).AsWideString;
        Shipping := DataSource.DataSet.FieldByName(CN_USER_SHIPPING).AsCurrency;
        VATShippingCurrency := DataSource.DataSet.FieldByName(CN_USER_VATSHIPPINGCURRENCY).AsWideString;
        VATShipping := DataSource.DataSet.FieldByName(CN_USER_VATSHIPPING).AsCurrency;
        TotalCurrency := DataSource.DataSet.FieldByName(CN_USER_TOTALCURRENCY).AsWideString;
        Total := DataSource.DataSet.FieldByName(CN_USER_TOTAL).AsCurrency;
        Payment := DataSource.DataSet.FieldByName(CN_USER_PAYMENT).AsWideString;
        DeliveryMode := DataSource.DataSet.FieldByName(CN_USER_DELIVERYMODE).AsWideString;
        ShareItOrderEMail := DataSource.DataSet.FieldByName(CN_USER_SHAREITORDEREMAIL).AsWideString;
        Result := 1;
    end;

    ADOQuery.Close;
    ADOConnection.Close;

end;

procedure TFormRegistrantDetails.LoadRegistration(ProjectTableName: String; UserID: String);
var
    RegistrantDetails: TRegistrantDetails;
begin
    Clear;
    SQLLoadRegistration(ProjectTableName, UserID, RegistrantDetails);
    with RegistrantDetails do begin
        EditCustomerID.Text := ID;
        EditCustomerRegistrationName.Text := RegistrationName;
        EditCustomerEmail.Text := Email;
        DateTimePickerRegistrationDate.DateTime := RegistrationTime;
        DateTimePickerRegistrationTime.Time := RegistrationTime;
        MemoCustomerComments.Text := Comments;
        //* V4
        EditCustomerSalutation.Text := Salutation;
        EditCustomerTitle.Text := Title;
        EditCustomerLastName.Text := LastName;
        EditCustomerFirstName.Text := FirstName;
        EditCustomerCompany.Text := Company;
        EditCustomerContactName.Text := ContactName;
        EditCustomerAddress.Text := Address;
        EditCustomerCity.Text := City;
        EditCustomerFullCity.Text := FullCity;
        EditCustomerCountry.Text := Country;
        EditCustomerPostalCode.Text := PostalCode;
        EditCustomerState.Text := StateProvince;
        EditCustomerTelephone.Text := Telephone;
        EditCustomerMobile.Text := MobilePhone;
        EditCustomerFax.Text := Fax;
        EditCustomerHomePage.Text := HomePage;
        CheckBoxNewsletter.Checked := AcceptsNewsLetters;
        EditCustomerVATID.Text := VATID;
        SpinEditNumberOfLicenses.Value := NoOfLicenses;
        EditCustomerLanguage.Text := Language;
        EditShareItRefNo.Text := ShareItRefNo;
        EditResellerValue.Text := Reseller;
        EditPromotionName.Text := PromotionName;
        EditNetSalesCurrency.Text := NetSalesCurrency;
        EditNetSalesValue.Text := CurrToStr(NetSales);
        EditNetDiscountCurrency.Text := NetDiscountCurrency;
        EditNetDiscountValue.Text := CurrToStr(NetDiscount);
        EditcollectedVATCurrency.Text := CollectedVATCurrency;
        EditcollectedVATValue.Text := CurrToStr(CollectedVAT);
        EditShippingCurrency.Text := ShippingCurrency;
        EditShippingValue.Text := CurrToStr(Shipping);
        EditVATOnShippingCurrency.Text := VATShippingCurrency;
        EditVATOnShippingValue.Text := CurrToStr(VATShipping);
        EditTotalCurrency.Text := TotalCurrency;
        EditTotalValue.Text := CurrToStr(Total);
        EditPaymentValue.Text := Payment;
        EditDeliveryModeValue.Text := DeliveryMode;
        //ShareItOrderEMail := DataSource.DataSet.FieldByName(CN_USER_SHAREITORDEREMAIL).AsWideString;
    end;
end;

function TFormRegistrantDetails.OrderAlreadyInDataBase(ProjectTableName: String; OrderID: String): Boolean;
begin

    //Result := False;

    try
        ADOConnection.Close;

        ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + FormSettings.EditDatabaseNameToUse.Text + ';');

        //* Insert a new record
        ADOQuery.SQL.Add('SELECT * FROM ' + ProjectTableName);
        ADOQuery.SQL.Add('WHERE ' + CN_USER_SHAREITREFNO + ' = ' + OrderID);
        ADOQuery.Open;

        Result := NOT DataSource.DataSet.IsEmpty;

    finally
        ADOQuery.Close;
        ADOConnection.Close;
    end;

end;

{
function TFormRegistrantDetails.GetUserRegistrationFromDataBase(ProjectTableName: AnsiString; RegistrationNumber: String): Boolean;
begin

    Result := False;

    try
        ADOConnection.Close;

        ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + FormSettings.EditDatabaseNameToUse.Text + ';');

        //* Insert a new record
        ADOQuery.SQL.Add('SELECT * FROM ' + ProjectTableName);
        ADOQuery.SQL.Add('WHERE ' + CN_USER_SHAREITREFNO + ' = ' + OrderID);
        ADOQuery.Open;

        Result := NOT DataSource.DataSet.IsEmpty;

    finally
        ADOQuery.Close;
        ADOConnection.Close;
    end;

end;
}

end.
