//********************************************************************************************************************************
//*                                                                                                                              *
//*     TRegistration 2.1.24.299  3delite 2006-2024                                                                             *
//*     See TRegistration ReadMe.txt for details                                                                                 *
//*                                                                                                                              *
//* Two licenses are available if you like this component:                                                                       *
//* Shareware license: 125                                                                                                      *
//*     http://www.shareit.com/product.html?productid=300091298                                                                  *
//* Commercial license: 250                                                                                                     *
//*     http://www.shareit.com/product.html?productid=300091297                                                                  *
//*                                                                                                                              *
//*     https://www.3delite.hu/Object Pascal Developer Resources/tregistration.html                                              *
//*                                                                                                                              *
//* If you have any of the aforementioned please email: 3delite@3delite.hu                                                       *
//*                                                                                                                              *
//* Good coding! :)                                                                                                              *
//* 3delite                                                                                                                      *
//********************************************************************************************************************************

unit DialogRegister;

interface

uses
  Winapi.Windows, System.SysUtils, System.Classes, Vcl.Graphics, UITypes,
  Vcl.Controls, Vcl.Forms, Vcl.StdCtrls, Vcl.ExtCtrls, RegistrationDefs;

type
  TFormRegister = class(TForm)
    GroupBox1: TGroupBox;
    Button1: TButton;
    Image1: TImage;
    LabelMain: TLabel;
    LabelRegisterNow: TLabel;
    LabelLinkRegister: TLabel;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure LabelHint1LinkMouseEnter(Sender: TObject);
    procedure LabelHint1LinkMouseLeave(Sender: TObject);
    procedure LabelLinkRegisterClick(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    FOwner: TComponent;
  public
    { Public declarations }
    Constructor Create(AOwner: TComponent); override;
    Destructor Destroy; override;
  end;

var
  FormRegister: TFormRegister;

implementation

{$R *.dfm}

Uses
    ShellApi;

Constructor TFormRegister.Create(AOwner: TComponent);
begin
    FOwner := AOwner;
    inherited Create(AOwner);
    //* Program name
    LabelMain.Caption := StringReplace(LabelMain.Caption, '%PROGNAME%', TRegistration(FOwner).TextAppName, [rfReplaceAll]);
    LabelRegisterNow.Caption := StringReplace(LabelRegisterNow.Caption, '%PROGNAME%', TRegistration(FOwner).TextAppName, [rfReplaceAll]);
    LabelLinkRegister.Caption := StringReplace(LabelLinkRegister.Caption, '%PROGNAME%', TRegistration(FOwner).TextAppName, [rfReplaceAll]);
    //* Price
    LabelRegisterNow.Caption := StringReplace(LabelRegisterNow.Caption, '%PRICE%', TRegistration(FOwner).TextPrice, [rfReplaceAll]);
end;

Destructor TFormRegister.Destroy;
begin
    FOwner := nil;
    inherited Destroy;
end;

procedure TFormRegister.Button1Click(Sender: TObject);
begin
    Close;
end;

procedure TFormRegister.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    //Action := caFree;
    //FormRegister := nil;
end;

procedure TFormRegister.FormCreate(Sender: TObject);
begin
    if Assigned(TRegistration(FOwner).OnRegistrationDialogCreate) then begin
        TRegistration(FOwner).OnRegistrationDialogCreate(FOwner, Self);
    end;
end;

procedure TFormRegister.Label1Click(Sender: TObject);
begin
    TRegistration(FOwner).FormRegistration.RequestNewVersionCode;
end;

procedure TFormRegister.Label3Click(Sender: TObject);
begin
    Self.Hide;
    TRegistration(FOwner).ShowModal;
    Close;
end;

procedure TFormRegister.LabelHint1LinkMouseEnter(Sender: TObject);
begin
    TLabel(Sender).Font.Style := TLabel(Sender).Font.Style + [fsUnderline];
end;

procedure TFormRegister.LabelHint1LinkMouseLeave(Sender: TObject);
begin
    TLabel(Sender).Font.Style := TLabel(Sender).Font.Style - [fsUnderline];
end;

procedure TFormRegister.LabelLinkRegisterClick(Sender: TObject);
begin
    ShellExecute(Handle, 'open', PChar(TRegistration(FOwner).URLRegistration), nil, nil, SW_SHOWNORMAL);
end;

end.
